/**
 * Fichero : data_base.c      Fecha:21/02/2018
 * Autores:                                   
 *                                            
 *  Implementación del TAD Base de Datos.
 *                                            
 */

#include "data_base.h"

#include "premiados.h"
#include "premios.h"
#include "premiado.h"
#include "premio.h"

#include <stdlib.h>


#define PREMIOS_FILE   "fpremios.csv"
#define PREMIADOS_FILE  "fpremiados.csv"

/* Estructura del TAD data_base */
struct _data_base {
  premiados * table_premiados;
  premios * table_premios;
};


/**
 *  Funciones auxiliares
 *
 */
char * create_path(const char *dirname, const char *filename);
premiados * bd_parse_file_premiados(char * file_name);
premiado * bd_parse_premiado(char * registro);
premios * bd_parse_file_premios(char * file_name, premiados * aa);
premio * bd_parse_premio(char * registro, premiados * aa);

/**
 * Funcion para crear una nueva base de datos, que 
 * contendrá los datos existentes en la raiz
 * pasada como parámetro.
 *
 * Entrada:
 *    Raiz de donde de los ficheros terminados en fpremiados.csv 
 *     (que contiene la informacion de los premiados) y fpremios.csv
 *     (que contiene los premios).
 *
 *      p.e. Si dirname es "datos/reducido_" entonces se debe abrir
 *           el fichero "datos/reducido_fpremiados.csv" para leer la
 *           info de los premiados y "datos/reducido_fpremios.csv"
 *           para los premios
 *
 *   Se puede implementar la funcion create_path como apoyo para
 *   crear las rutas a los ficheros
 *
 * Salida:
 *    Una estructura data_base inicializada o NULL en caso de error
 */
data_base * new_data_base(const char *dirname)
{
    /* (PRACTICA: a rellenar) */
    return NULL;
}

/**
 * Funcion para liberar la memoria reservada y los recursos de la
 * base de datos.
 *
 * Entrada:
 *    Estructura data_base a liberar
 */
void destroy_data_base(data_base *db)
{
    /* (PRACTICA: a rellenar) */
}


/**
 * Funcion para añadir un nuevo premio en la base de datos.
 * Comprueba que el premio no esté repetido (según su id, su 
 * clave primaria).
 * También se comprueba que todos los premiados del premio están
 * previamente añadidos a la base de datos.
 *
 * Entrada:
 *    La base de datos donde se añade y el premio a añadir.
 * Salida:
 *    Falso si el premio no se pudo añadir por no cumplir alguna restricción.
 */
BOOL data_base_add_premio(data_base *db, premio *f)
{
    /* (PRACTICA: a rellenar) */
    return FALSE;
}

/**
 * Funcion para añadir un nuevo premiado en la base de datos.
 * Comprueba que no esté repetido (según su id, su 
 * clave primaria).
 *
 * Entrada:
 *    La base de datos donde se añade y el premio a añadir.
 * Salida:
 *    Falso si el premio está repetida y no se pudo añadir.
 */
BOOL data_base_add_premiado(data_base *db, premiado *a)
{  
    /* (PRACTICA: a rellenar) */
    return FALSE;
}


/********** Funciones de consulta ************/

/**
 * Funcion para recuperar un premiado dado su id.
 *
 * Entrada:
 *    Estructura base de datos y el id del premiado a recuperar.
 *
 * Salida:
 *    Un puntero al premiado o NULL si no se encuentra.
 */
premiado * find_premiado_by_id(data_base * db, int id)
{
    /* (PRACTICA: a rellenar) */
    return NULL;
}

/**
 * Funcion para recuperar una premio dado su id.
 *
 * Entrada:
 *    Estructura base de datos y el id de el premio a recuperar.
 *
 * Salida:
 *    Un puntero a el premio o NULL si no se encuentra.
 */
premio * find_premio_by_id(data_base * db, int id)
{
    /* (PRACTICA: a rellenar) */
    return NULL;
}


